<?php
    // Test de l'installation
    if (!file_exists( "../chat/inc/chat.php") or !file_exists( "../chat/inc/database.php") or !file_exists( "../chat/inc/externe.php")) {
        echo( "<html><body>Vous devez lancer le script <b>install.php</b> de Chaton avant de dmarrer.</body></html>");
        exit;
    }

    // Inclus specifiques au chat
    require_once( "../chat/inc/chat.php");
    require_once( "../chat/inc/langue.php");

    ob_start();
?>
<!-- <?php echo( "$chat_copy $chat_version" ); ?> Copyright GoUaRfIg! -->
<form name="identification" method="post" action="../chat/entree.php" onSubmit="envoyer.disabled=true;">
  <input type="hidden" name="lang" value="<?php echo( $lang); ?>">
  <table width="100%" border="0" cellspacing="2" cellpadding="2" class="contenu_interieur">
    <tr align="right"> 
      <td colspan="2">&nbsp; </td>
    </tr>
    <tr> 
      <td align="right"> Pseudo : </td>
      <td> <input type="text" name="newlogin" size="20" maxlength="30"> </td>
    </tr>
    <tr> 
      <td align="right"> Mot de passe : </td>
      <td> <input type="password" name="newmdp" size="20" maxlength="30"> </td>
    </tr>
    <tr> 
      <td colspan="2">&nbsp;</td>
    </tr>
    <tr> 
      <td align="right" valign="top"> Salons publics : </td>
      <td> 
        <?php
                // Affichage des salons publics
                foreach( $salon_public as $nom_interne => $nom_salle) {
                    // Bouton de choix du salon
                    echo( "<input type=\"radio\" name=\"newsalon\" value=\"$nom_interne\"");
					// Salon par defaut = premier salon
					if (!$salon_par_defaut) {
						$salon_par_defaut = true;
						echo( " checked");
					}
					// Affichage du nom du salon
					echo( ">$nom_salle<br>\n");
                }
              ?>
      </td>
    </tr>
    <tr> 
      <td colspan="2">&nbsp;</td>
    </tr>
    <?php if (defined( "AUTORISER_SALONS_PRIVES") and (AUTORISER_SALONS_PRIVES == true)) { ?>
    <tr> 
      <td align="right" valign="top"> Salons priv&eacute;s : </td>
      <td> 
        <input type="radio" name="newsalon" value="">
        Cr&eacute;er un nouveau salon </td>
    </tr>
    <tr> 
      <td align="right"> Cr&eacute;er un salon priv&eacute; : </td>
      <td> <input type="text" name="creersalon" size="20" maxlength="50"> </td>
    </tr>
    <tr> 
      <td align="right"> Mot de passe : </td>
      <td> <input type="text" name="mdpsalon" size="20" maxlength="50">
        (<i>optionnel</i>) </td>
    </tr>
    <tr> 
      <td colspan="2">&nbsp;</td>
    </tr>
    <?php} ?>
    <tr align="center"> 
      <td colspan="2"> <input type="submit" name="envoyer" value="Entrer dans le chat !"> 
      </td>
    </tr>
    <tr> 
      <td colspan="2" align="right" class="etat"><font size="1"> <?php echo( "$chat_copy Version $chat_version"); ?> 
        </font></td>
    </tr>
  </table>
</form>
<?php
    if (isset( $erreur)) {
?>
<script language="javascript">
  window.alert("<?php echo( $erreur); ?>");
</script>
<?php
    }
    $affichage_php = ob_get_contents();
    ob_end_clean();
?>
