<?php
//*************************************************************
//
// Cryptage des mots de passe
//
// Note : La volont de l'auteur n'est pas de proposer un
//        cryptage efficace et sr, mais simplement
//        qu'on ne puisse pas voir directement le mot de passe
//        avec un diteur MySQL...
//
// Projet      : Chaton
// Version     : 1.4.5
// Date        : 27 Mai 2005
//
//*************************************************************

define( "CODE_CRYPTAGE_ROT13", '$13$');

//*************************************************************
// Fonction de cryptage rot13 pour PHP < 4.2
//*************************************************************

    if (!function_exists('str_rot13')) {

        function str_rot13( $str) {
            $from = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
            $to  = 'nopqrstuvwxyzabcdefghijklmNOPQRSTUVWXYZABCDEFGHIJKLM';
            return strtr($str, $from, $to);
        }
    }

//*************************************************************
// Encryptage d'un mot de passe
//*************************************************************

Function Encrypte( $chaine) {
    $retour = '';

    $retour = str_rot13( $chaine);
    if ($retour) {
        $retour = CODE_CRYPTAGE_ROT13 . $retour;
    } else {
        // Erreur de cryptage
        $retour = $chaine;
    }

    return $retour;
}

//*************************************************************
// Dcryptage d'un mot de passe
//
// La fonction reconnait un mot de passe NON crypt,
// et le renvoi tel quel.
//*************************************************************

Function Decrypte( $chaine) {
    // Mot de passe impossible
    $retour = md5(mt_rand());

    if ($chaine) {
        if (substr( $chaine, 0, strlen( CODE_CRYPTAGE_ROT13)) == CODE_CRYPTAGE_ROT13) {
            $retour = str_rot13( substr( $chaine, 4));
        } else {
            // Non crypt
            $retour = $chaine;
        }
    }

    return $retour;
}

?>