<?php

//*************************************************************
//
// Gestionnaire des utilisateurs de CHAT
//
//  Traduction : Ok
//
// Projet      : Chaton
// Version     : 1.6.3
// Date        : 8 avril 2007
//
//*************************************************************

    require_once( "inc/mysql.php");

    define( "PRIV_SANS_ACCES",      0);
    define( "PRIV_UTILISATEUR",     1);
    define( "PRIV_NON_ENREGISTRE",  2);
    define( "PRIV_ROBOT",           3);
    define( "PRIV_ANIMATEUR",       4);
    define( "PRIV_OPERATEUR",       5);
    define( "PRIV_ADMINISTRATEUR",  10);

    define( "FLAG_REFRESH_USER",    1);

    if (!defined('CL_NOIR')) define( 'CL_NOIR', 0);
    if (!defined('CL_BLANC')) define( 'CL_BLANC', 16777215);

    // Date des interventions
    // date PHP :   $date_heure = "'" . date( 'Y-m-d H:i:s') . "'";
    // date MySQL : $date_heure = 'now()';
    $date_heure = 'now()';

//*************************************************************
// Chargement d'une session utilisateur
//*************************************************************

Function ChargeUtilisateur( $chat_cookie) {
    Global $chat_base, $table_utilisateur;
    Global $chat_uid, $chat_login, $chat_hide, $chat_sid, $chat_salon, $chat_priv, $chat_defilement, $chat_modeuser, $chat_proprietaire, $chat_oqp, $chat_ignore, $chat_deconnexion, $chat_lang, $chat_couleur, $chat_flags, $chat_version_salon;

    if (($chat_base) and ($chat_cookie)) {
        $requete = mysql_query( "SELECT id,login,hide,sid,salon,priv,defilement,mode_user,proprietaire,oqp,deconnexion,lang,couleur,flags,version FROM $table_utilisateur WHERE cookie='$chat_cookie'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1) {
                // Charge les donnees
                list( $chat_uid, $chat_login, $chat_hide, $chat_sid, $chat_salon, $chat_priv, $chat_defilement, $chat_modeuser, $chat_proprietaire, $chat_oqp, $chat_deconnexion, $chat_lang, $chat_couleur, $chat_flags, $chat_version_salon) = mysql_fetch_row( $requete);
                return( True);
            } else {
                return( False);
            }
        } else {
            return( False);
        }
    } else {
        // mysql_journal( $chat_base, "(ChargeUtilisateur) Impossible de charger le cookie '$chat_cookie' !");
        return( False);
    }
}

//*************************************************************
//  Ajoute un utilisateur
//*************************************************************

Function AjouteUtilisateur( $cookie, $loginchat, $priv, $ip, $lang, $flags, $robot = false, $parent = 0) {
    Global $chat_base, $table_utilisateur, $table_ban_pseudo, $table_ban_ip, $date_heure;

    if (($loginchat) and ($ip) and ($priv > 0)) {
        $requete = mysql_query( "SELECT id FROM $table_utilisateur WHERE login='$loginchat'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) > 0) {
                // Un utilisateur existe deja
                return -3;
            } else {
                // Verifie le banissement du pseudo
                $requete = mysql_query( "SELECT id FROM $table_ban_pseudo WHERE pseudo='$loginchat' AND fin >= $date_heure", $chat_base);
                if ($requete) {
                    if (mysql_num_rows( $requete) == 0) {
                        // Verifie le banissement de l'adresse ip
                        $requete = mysql_query( "SELECT id FROM $table_ban_ip WHERE ip='$ip' AND fin >= $date_heure", $chat_base);
                        if ($requete) {
                            if (mysql_num_rows( $requete) == 0) {
                                // Aller, on l'ajoute va !
                                mt_srand((double)microtime()*1000000);
                                $uid = mt_rand( 1, 65000);
                                if ($cookie == '') $cookie = $uid;
                                // Verifie que le cookie est disponible
                                $requete = mysql_query( "SELECT id FROM $table_utilisateur WHERE cookie='$cookie'", $chat_base);
                                if ($requete) {
                                    if (mysql_num_rows( $requete) == 0) {
                                        $requete = mysql_query( "INSERT INTO $table_utilisateur (id,cookie,login,priv,numero,robot,parent,lang,flags,ip,cnx,enr) VALUES('$uid','$cookie','$loginchat','$priv','0','$robot','$parent','$lang','$flags','$ip',$date_heure,now()) ", $chat_base);
                                        return( $uid);
                                    } else {
                                        // Le cookie est dj en liste
                                        return -5;
                                    }
                                } else {
                                    // Erreur
                                    return -2;
                                }
                            } else {
                                // Houlala il est dans la liste !
                                return -4;
                            }
                        } else {
                            // Erreur
                            return -2;
                        }
                    } else {
                        // Houlala il est dans la liste !
                        return -4;
                    }
                } else {
                    // Erreur
                    return -2;
                }
            }
        } else {
            // Erreur ?
            return -2;
        }
    } else {
        // Donnees incompletes
        return -1;
    }
}


//*************************************************************
//  Entree d'un utilisateur dans le salon
//*************************************************************

Function DansLeSalon( $uid, $sid, $salon) {
    Global $chat_base, $table_utilisateur;

    if (($uid) and ($sid) and ($salon)) {
        $salon = mysql_real_escape_string( $salon, $chat_base);
        $requete = mysql_query( "UPDATE $table_utilisateur SET sid='$sid',salon='$salon',version=0 WHERE id='$uid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Proprietaire d'un salon
//*************************************************************

Function ChangeProprietaire( $uid, $sid) {
    Global $chat_base, $table_utilisateur, $table_salle;

    if (($uid) and ($sid)) {
        $requete = mysql_query( "UPDATE $table_utilisateur SET proprietaire='$sid' WHERE id='$uid' LIMIT 1", $chat_base);
        if ($requete) {
            return (mysql_affected_rows($chat_base) == 1);
        } else {
            return false;
        }
    } else {
        return false;
    }
}


//*************************************************************
//  Emotion de l'utilisateur
//*************************************************************

Function ChangeEtat( $uid, $sid, $etat) {
    Global $chat_base, $table_utilisateur, $table_salle;

    if (($uid) and ($sid) and ($etat)) {
        $etat = mysql_real_escape_string( $etat, $chat_base);
        $requete = mysql_query( "UPDATE $table_utilisateur SET etat='$etat' WHERE id='$uid' LIMIT 1", $chat_base);
        $requete = mysql_query( "UPDATE $table_salle SET version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Mode d'affichage des salons (courant / tous)
//*************************************************************

Function ChangeModeUser( $uid, $etat) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        $etat = mysql_real_escape_string( $etat, $chat_base);
        $requete = mysql_query( "UPDATE $table_utilisateur SET mode_user='$etat' WHERE id='$uid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Dfilement de l'utilisateur
//*************************************************************

Function ChangeDefilement( $uid, $etat) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        $etat = mysql_real_escape_string( $etat, $chat_base);
        $requete = mysql_query( "UPDATE $table_utilisateur SET defilement='$etat' WHERE id='$uid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Couleur par dfaut
//*************************************************************

Function ChangeCouleur( $uid, $couleur) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        if (is_null( $couleur)) {
            $requete = mysql_query( "UPDATE $table_utilisateur SET couleur=NULL WHERE id='$uid' LIMIT 1", $chat_base);
        } elseif ((is_numeric( $couleur)) and ($couleur >= CL_NOIR) and ($couleur <= CL_BLANC )) {
            $requete = mysql_query( "UPDATE $table_utilisateur SET couleur='$couleur' WHERE id='$uid' LIMIT 1", $chat_base);
        }
    }
}


//*************************************************************
//  Utilisateur absent/occup
//*************************************************************

Function ChangeOqp( $uid, $sid, $oqp) {
    Global $chat_base, $table_utilisateur, $table_salle;

    if (($uid) and ($sid)) {
        $oqp = mysql_real_escape_string( $oqp, $chat_base);
        $requete = mysql_query( "UPDATE $table_utilisateur SET oqp='$oqp' WHERE id='$uid' LIMIT 1", $chat_base);
        $requete = mysql_query( "UPDATE $table_salle SET version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Deconnecte un utilisateur
//*************************************************************

Function DeconnecteUtilisateur( $uid, $robot = false) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        $requete = mysql_query( "UPDATE $table_utilisateur SET deconnexion=1 WHERE id='$uid' AND robot='$robot' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Enleve un utilisateur
//*************************************************************

Function EnleveUtilisateur( $uid, $robot = false) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        $requete = mysql_query( "DELETE FROM $table_utilisateur WHERE id='$uid' AND robot='$robot' LIMIT 1", $chat_base);
        if (mysql_affected_rows( $chat_base) > 0) {
            return( true);
        } else {
            return( false);
        }
    } else {
        return( false);
    }
}


//*************************************************************
//  Cache un utilisateur
//*************************************************************

Function CacheUtilisateur( $uid, $sid = 0) {
    Global $chat_base, $table_utilisateur, $table_salle;

    if ($sid) {
        $requete = mysql_query( "UPDATE $table_salle SET nb_hide=nb_hide+1 WHERE id='$sid' LIMIT 1", $chat_base);
    }
    if ($uid) {
        $requete = mysql_query( "UPDATE $table_utilisateur SET hide='1' WHERE id='$uid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Reaffiche un utilisateur cache
//*************************************************************

Function AfficheUtilisateur( $uid, $sid = 0) {
    Global $chat_base, $table_utilisateur, $table_salle;

    if ($sid) {
        $requete = mysql_query( "UPDATE $table_salle SET nb_hide=nb_hide-1 WHERE id='$sid' LIMIT 1", $chat_base);
    }
    if ($uid) {
        $requete = mysql_query( "UPDATE $table_utilisateur SET hide='0' WHERE id='$uid' LIMIT 1", $chat_base);
    }
}


//*************************************************************
//  Retourne un uid utilisateur
//*************************************************************

Function idUtilisateur( $nom_utilisateur, $robot = false) {
    Global $chat_base, $table_utilisateur;

    if ($nom_utilisateur) {
        $nom_utilisateur = mysql_real_escape_string( $nom_utilisateur, $chat_base);
        $requete = mysql_query( "SELECT id,sid FROM $table_utilisateur WHERE login='$nom_utilisateur' AND robot='$robot'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1 ) {
                return( array( mysql_result( $requete, 0, "id"), mysql_result( $requete, 0, "sid")) );
            } else {
                return( array( 0, 0) );
            }
        }
    }
}


//*************************************************************
//  Retourne un login utilisateur a partir de son id
//*************************************************************

Function GetUserName( $uid, $parent = 0) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        $requete = mysql_query( "SELECT login FROM $table_utilisateur WHERE id='$uid' AND parent='$parent'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1 ) {
                return( mysql_result( $requete, 0, "login"));
            } else {
                return( 0);
            }
        } else {
            return( 0);
        }
    } else {
        return( 0);
    }
}

//*************************************************************
//  Retourne l'adresse IP d'un utilisateur
//*************************************************************

Function GetUserIp( $nom_utilisateur) {
    Global $chat_base, $table_utilisateur;

    if ($nom_utilisateur) {
        $nom_utilisateur = mysql_real_escape_string( $nom_utilisateur, $chat_base);
        $requete = mysql_query( "SELECT ip FROM $table_utilisateur WHERE login='$nom_utilisateur' AND robot='0'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1 ) {
                return( mysql_result( $requete, 0, "ip"));
            } else {
                return( '');
            }
        } else {
            return( '');
        }
    } else {
        return( '');
    }
}

//*************************************************************
//  Retourne la date de connexion d'un id utilisateur
//*************************************************************

Function GetUserCnx( $uid, $format_date) {
    Global $chat_base, $table_utilisateur;

    if ($uid) {
        $requete = mysql_query( "SELECT DATE_FORMAT(cnx, '$format_date') as cnx FROM $table_utilisateur WHERE id='$uid'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1 ) {
                return( mysql_result( $requete, 0, "cnx"));
            } else {
                return( "select $chaine_cnx from $table_utilisateur where id='$uid'");
            }
        }
    }
}

//*************************************************************
//  Retourne les informations sur l'utilisateur
//*************************************************************

Function InfosUtilisateur( $login, $format_date) {
    Global $chat_base, $table_base_utilisateur;

    $utilisateur = 0;
    if ($login) {
        $login = mysql_real_escape_string( strtolower( $login), $chat_base);
        $requete = mysql_query( "SELECT id,nom,prenom,sexe,DATE_FORMAT(naissance, '$format_date') as naissance,mdp,DECODE(mdp_encoded,'" . PASS_MYSQL . "') as mdp2,priv,nb_cnx_chat,email,pays,fuseau,bio,nom_site,url_site FROM $table_base_utilisateur WHERE login='$login'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1 ) {
                $utilisateur = mysql_fetch_array( $requete);
                if ($utilisateur['mdp2']) $utilisateur['mdp'] = $utilisateur['mdp2'];
            }
        }
    }

    return( $utilisateur );
}


//*************************************************************
//  Retourne le nombre d'utilisateurs en ligne
//*************************************************************

Function NombreUtilisateurs() {
    Global $chat_base, $table_utilisateur;

    $requete = mysql_query( "SELECT count(id) FROM $table_utilisateur WHERE hide='0'", $chat_base);
    if ($requete) {
        return mysql_result( $requete, 0, 0);
    } else {
        return 0;
    }
}


//*************************************************************
//  Retourne les informations d'un utilisateur  partir de
//  son email
//*************************************************************

Function InfosUtilisateursParEmail( $email) {
    Global $chat_base, $table_base_utilisateur;

    $tableau_retour = array();

    if( $email) {
        $email = mysql_real_escape_string( strtolower( $email), $chat_base);
        $requete = mysql_query( "SELECT nom,prenom,login,mdp,DECODE(mdp_encoded,'" . PASS_MYSQL . "') as mdp2 FROM $table_base_utilisateur WHERE email='$email'", $chat_base);
        if ($requete) {
            while( $utilisateur = mysql_fetch_array( $requete)) {
                if ($utilisateur['mdp2']) $utilisateur['mdp'] = $utilisateur['mdp2'];
                $tableau_retour[] = $utilisateur;
            }
        }
    }
    return $tableau_retour;
}

//*************************************************************
//  Bannir un utilisateur
//*************************************************************

Function BannirUtilisateur( $chat_login, $nom_indesirable, $ip_courante) {
    Global $chat_base, $table_ban_pseudo, $date_heure;

    if ($nom_indesirable) {
        // Ajoute le nom dans la liste des pseudos indesirables
        $requete = mysql_query( "SELECT pseudo FROM $table_ban_pseudo WHERE pseudo='$nom_indesirable'");
        if (mysql_num_rows( $requete) == 0) {
            // Nouvel utilisateur
            $requete = mysql_query( "INSERT INTO $table_ban_pseudo (pseudo,debut,fin,qui,last_ip) VALUES ('$nom_indesirable',$date_heure,date_add( $date_heure, interval 12 hour),'$chat_login','$ip_courante')");
            return( 1);
        } else {
            $requete = mysql_query( "UPDATE $table_ban_pseudo SET fin=date_add( $date_heure, interval 12 hour), qui='$chat_login', last_ip='$ip_courante' WHERE pseudo='$nom_indesirable' LIMIT 1");
            return( 2);
        }
    }
}

//*************************************************************
//  Rintgrer un utilisateur banni
//*************************************************************

Function ReintegrerUtilisateur( $nom_indesirable) {
    Global $chat_base, $table_ban_pseudo;

    // Supprime le nom dans la liste des pseudos indesirables
    $requete = mysql_query( "DELETE FROM $table_ban_pseudo WHERE pseudo='$nom_indesirable' LIMIT 1");
    if (mysql_affected_rows( ) > 0) {
        return( true);
    } else {
        return( false);
    }
}

//*************************************************************
//  Bannir une adresse IP
//*************************************************************

Function BannirIp( $chat_login, $ip_indesirable) {
    Global $chat_base, $table_ban_ip, $date_heure;

    if ($ip_indesirable) {
        // Ajoute le nom dans la liste des IPs indesirables
        $requete = mysql_query( "SELECT ip FROM $table_ban_ip WHERE ip='$ip_indesirable'");
        if (mysql_num_rows( $requete) == 0) {
            // Nouvelle entre
            $requete = mysql_query( "INSERT INTO $table_ban_ip (ip,debut,fin,qui) VALUES ('$ip_indesirable',$date_heure,date_add( $date_heure, interval 12 hour),'$chat_login')");
            return( 1);
        } else {
            $requete = mysql_query( "UPDATE $table_ban_ip SET fin=date_add( $date_heure, interval 12 hour), qui='$chat_login' WHERE ip='$ip_indesirable' LIMIT 1");
            return( 2);
        }
    }
}

//*************************************************************
//  Rintgrer une adresse IP bannie
//*************************************************************

Function ReintegrerIp( $ip_indesirable) {
    Global $chat_base, $table_ban_ip;

    // Supprime l'ip dans la liste des ips indesirables
    $requete = mysql_query( "DELETE FROM $table_ban_ip WHERE ip='$ip_indesirable' LIMIT 1");
    if (mysql_affected_rows( ) > 0) {
        return( true);
    } else {
        return( false);
    }
}

?>
