<?php
//*************************************************************
//
// Gestionnaire des langues
//
// Projet      : Chaton
// Version     : 1.5.0
// Date        : 17 Juin 2005
//
//*************************************************************

    // Pour les versions antrieures  la 1.1.0 :
    // 0 = Anglais
    // 1 = Franais
    // 2 = Langue personnalise

    // Tableau des langues actuelles
    $langues_dispo['en'] = 'Anglais';
    $langues_dispo['fr'] = "Fran&ccedil;ais";
    $langues_dispo['ru'] = "Russe";
    $langues_dispo['en-perso'] = 'Anglais personnalis&eacute;';
    $langues_dispo['fr-perso'] = "Fran&ccedil;ais personnalis&eacute;";

    if (!defined( "LANGUE_PAR_DEFAUT")) define( "LANGUE_PAR_DEFAUT", 'en');
    define( "LANGUE_EN", 'en');
    define( "LANGUE_FR", 'fr');
    define( "LANGUE_RU", 'ru');

    // La langue a t'elle t passe en url ?
    if (strtoupper($_SERVER["REQUEST_METHOD"]) == "POST") {
        if (isset( $_POST['lang'])) $lang = $_POST['lang'];
    } else if (strtoupper($_SERVER["REQUEST_METHOD"]) == "GET") {
        if (isset( $_GET['lang'])) $lang = $_GET['lang'];
    }

    if (defined( "MULTILANGUE") and (MULTILANGUE == true)) {
        // Dtection automatique de la langue demande
        if (!isset($lang)) {
            if (isset( $_SERVER["HTTP_ACCEPT_LANGUAGE"])) {
                $premier = substr( $_SERVER["HTTP_ACCEPT_LANGUAGE"], 0, 2);
                if (strcasecmp($premier, 'fr') == 0) {
                    $lang = LANGUE_FR;
                } elseif (strcasecmp($premier, 'ru') == 0) {
                    $lang = LANGUE_RU;
                } else {
                    $lang = LANGUE_PAR_DEFAUT;
                }
            } else {
                $lang = LANGUE_PAR_DEFAUT;
            }
        } else {
            // Au cas o...
            if ($lang == '') {
                $lang = LANGUE_PAR_DEFAUT;
            } elseif ($lang === '0') {
                $lang = LANGUE_EN;
            } elseif ($lang === '1') {
                $lang = LANGUE_FR;
            }
        }
    } else {
        // Mono-langue
        $lang = LANGUE_PAR_DEFAUT;
    }

    // Chargement de la configuration globale de la langue
    if (file_exists( "lang/$lang/langue.php")) {
        include_once( "lang/$lang/langue.php");
    }

    // Encodage par dfaut des pages
    if (!defined( 'CHARSET')) define( "CHARSET", "iso-8859-1");

?>