<?php
//*************************************************************
//
// - Affichage de la liste des utilisateurs
// - Affichage des nouveaux messages
//   sur le CHAT
//
// Projet      : Chaton
// Version     : 1.6.1
// Date        : 8 novembre 2006
//
//*************************************************************

    // Inclus du chat
    require_once( "inc/chat.php");
    require_once( "inc/securite.php");
    require_once( "inc/langue.php");
    require_once( "inc/database.php");
    require_once( "inc/log.php");
    require_once( "inc/users.php");
    require_once( "inc/salons.php");
    require_once( "inc/menage.php");
    require_once( "inc/nocache.php");


//*************************************************************
//  Affichage d'un pseudo dans la liste
//*************************************************************

    function AffichePseudo( $chat_login, $cur_pseudo, $cur_robot, $cur_priv, $salle_courante, $cur_oqp, $cur_etat, $cur_proprietaire) {
        Global $chat_lang, $chat_priv, $langue_user;

        echo( "$cur_pseudo|");
    }

//*************************************************************
//  Programme principal
//*************************************************************

    chat_open();

    Header( "Refresh: $taux_rafraichissement");

    // 10% de chances de faire le menach'
    if (mt_rand( 0, 9) == 0) {
        Menage( $chat_base, $table_utilisateur);
    }

    if (isset($chat_cookie) and ChargeUtilisateur( $chat_cookie)) {

        // Initialisations
        $chat_appel = false;

        // Charge le module de langue associ au script courant
        if (file_exists( "lang/$chat_lang/user.php")) {
            include( "lang/$chat_lang/user.php");
        }

        // Changement du mode d'affichage
        if (isset( $mode)) {
            $chat_modeuser = $mode;
            ChangeModeUser( $chat_uid, $chat_modeuser);
        }

        // Utilisateur actif ?
        if ($chat_deconnexion) {
            $actif = false;
        } else {
            $actif = true;
        }

        // Salon actif ?
        $requete = mysql_query( "SELECT id FROM $table_salle WHERE id='$chat_sid'");
        if ($requete) {
            if (mysql_num_rows( $requete) < 1) {
                $actif = false;
            }
        }

        if ($actif) {

            $chaine_discussion = Discussion( $chat_uid, $chat_login, $chat_sid);
            if ($chaine_discussion != '') echo( "<***>$chaine_discussion</***>");

            if ($chat_modeuser == 1) {
                // Affichage de la liste complte des salles actives
                echo( "<tr><td align=\"center\" colspan=\"2\" class=\"info\"><a href=\"user.php?mode=0\" class=\"info\">" . $langue_user["dusalon"] . "</a> | " . $langue_user["tous"] . "</td></tr>\n");

                $requete = mysql_query( "SELECT $table_utilisateur.login,$table_utilisateur.robot,$table_utilisateur.priv,$table_utilisateur.oqp,$table_utilisateur.etat,$table_utilisateur.proprietaire,$table_utilisateur.sid,$table_salle.nom as salle,$table_salle.nombre,$table_salle.max,$table_salle.mdp from $table_utilisateur,$table_salle where $table_utilisateur.sid=$table_salle.id and $table_utilisateur.hide='0' order by salle,login");
                if ($requete) {
                    if (mysql_num_rows( $requete) > 0) {
                        $ancienne_salle = '';
                        $salle_courante = 0;
                        for( $i=0; $i<mysql_num_rows( $requete); $i++) {
                            $cur_pseudo = mysql_result( $requete, $i, "login");
                            $cur_robot = mysql_result( $requete, $i, "robot");
                            $cur_priv = mysql_result( $requete, $i, "priv");
                            $cur_oqp = mysql_result( $requete, $i, "oqp");
                            $cur_etat = mysql_result( $requete, $i, "etat");
                            $cur_sid = mysql_result( $requete, $i, "sid");
                            $cur_salle = mysql_result( $requete, $i, "salle");
                            $cur_nombresalle = mysql_result( $requete, $i, "nombre");
                            $cur_maxsalle = mysql_result( $requete, $i, "max");
                            $cur_mdpsalle = mysql_result( $requete, $i, "mdp");
                            $cur_proprietaire = mysql_result( $requete, $i, "proprietaire");
                            if ($cur_proprietaire == $cur_sid) {
                                $cur_proprietaire = true;
                            } else {
                                $cur_proprietaire = false;
                            }
                            if ($ancienne_salle <> $cur_salle) {
                                // Affichage de la salle
                                $ancienne_salle = $cur_salle;
                                $nomsalle = NomSalonPublic( $cur_salle);
                                if ($nomsalle == '') $nomsalle = $cur_salle;

                                if ($cur_maxsalle < MAX_SALON) {
                                    $chaine_maxsalle = "/$cur_maxsalle";
                                } else {
                                    $chaine_maxsalle = "";
                                }

                                if ($cur_salle == $chat_salon) {
                                    echo( "<tr><td colspan=\"2\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"salle\" nowrap>&nbsp;<b>$nomsalle</b> ($cur_nombresalle$chaine_maxsalle)<hr></td></tr>\n");
                                    $salle_courante = 1;
                                } else {
                                    if ( $cur_mdpsalle) {
                                        echo( "<tr><td colspan=\"2\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"salle\" nowrap>&nbsp;<b>$nomsalle</b> (Priv&eacute;)<hr></td></tr>\n");
                                    } else {
                                        echo( "<tr><td colspan=\"2\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"salle\" nowrap>&nbsp;<a href=\"deplacer.php?newsalon=" . urlencode( $cur_salle) . "\" class=\"salle\"><b>$nomsalle</b></a> ($cur_nombresalle$chaine_maxsalle)<hr></td></tr>\n");
                                    }
                                    $salle_courante = 0;
                                }
                            }
                            AffichePseudo( $chat_login, $cur_pseudo, $cur_robot, $cur_priv, $salle_courante, $cur_oqp, $cur_etat, $cur_proprietaire);
                        }
                    }
                }

                // Salles vides
                if (defined('AFFICHER_SALLES_VIDES') and (AFFICHER_SALLES_VIDES == true)) {
                    $requete = mysql_query( "SELECT nom,nombre,max,mdp from $table_salle where $table_salle.nombre='0' order by nom");
                    if ($requete) {
                        if (mysql_num_rows( $requete) > 0) {
                            for( $i=0; $i<mysql_num_rows( $requete); $i++) {
                                $cur_salle = mysql_result( $requete, $i, "nom");
                                $cur_nombresalle = mysql_result( $requete, $i, "nombre");
                                $cur_maxsalle = mysql_result( $requete, $i, "max");
                                $cur_mdpsalle = mysql_result( $requete, $i, "mdp");

                                // Affichage de la salle
                                $nomsalle = NomSalonPublic( $cur_salle);
                                if ($nomsalle == '') $nomsalle = $cur_salle;

                                if ($cur_maxsalle < MAX_SALON) {
                                    $chaine_maxsalle = "/$cur_maxsalle";
                                } else {
                                    $chaine_maxsalle = "";
                                }

                                if ( $cur_mdpsalle) {
                                    echo( "<tr><td colspan=\"2\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"salle\" nowrap>&nbsp;<b>$nomsalle</b> (Priv&eacute;)<hr></td></tr>\n");
                                } else {
                                    echo( "<tr><td colspan=\"2\">&nbsp;</td></tr>\n<tr><td colspan=\"2\" class=\"salle\" nowrap>&nbsp;<a href=\"deplacer.php?newsalon=" . urlencode( $cur_salle) . "\" class=\"salle\"><b>$nomsalle</b></a> ($cur_nombresalle$chaine_maxsalle)<hr></td></tr>\n");
                                }
                            }
                        }
                    }
                }

            } else {
                // Utilisateurs du salon courant
                echo( "<***pseudo***>");

                $requete = mysql_query( "SELECT login,robot,priv,oqp,etat,proprietaire FROM $table_utilisateur WHERE sid='$chat_sid' AND hide='0' ORDER BY login");
                if ($requete) {
                    if (mysql_num_rows( $requete) > 0) {
                        for( $i=0; $i<mysql_num_rows( $requete); $i++) {
                            $cur_pseudo = mysql_result( $requete, $i, "login");
                            $cur_robot = mysql_result( $requete, $i, "robot");
                            $cur_priv = mysql_result( $requete, $i, "priv");
                            $cur_oqp = mysql_result( $requete, $i, "oqp");
                            $cur_etat = mysql_result( $requete, $i, "etat");
                            $cur_proprietaire = mysql_result( $requete, $i, "proprietaire");
                            if ($cur_proprietaire == $chat_sid) {
                                $cur_proprietaire = true;
                            } else {
                                $cur_proprietaire = false;
                            }
                            AffichePseudo( $chat_login, $cur_pseudo, $cur_robot, $cur_priv, True, $cur_oqp, $cur_etat, $cur_proprietaire);
                        }
                    }
                }
                echo( "</***pseudo***>");
            }
?>
<?php
        } else {
            // Utilisateur non reference :-(
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body OnLoad='javascript:parent.document.location.href="sortie.php"'>
</body>
</html>
<?php
        }
    } else {
        // Base de donnees impossible a ouvrir
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>
<br>
<b>The database cannot be opened,<br>
or you are not connected</b><br>
Please wait or try to reconnect...<br>
<br>
<i>La base de donn&eacute;es est occup&eacute;e,<br>
ou vous n'&ecirc;tes plus connect&eacute;</i><br>
Veuillez attendre ou vous reconnecter.<br>
</body>
</html>
<?php
    }
    chat_close();

?>